package ${basePackage}.action.ajax.system;

import ${basePackage}.frame.auth.LocalData;
import ${basePackage}.frame.excel.WSheet;
import ${basePackage}.frame.utils.MapperUtil;
import ${basePackage}.module.system.mgr.DictManager;
import ${basePackage}.module.system.req.*;
import ${basePackage}.module.system.rsp.*;
import ${basePackage}.frame.base.BaseResponse;
import ${basePackage}.frame.base.ErrorType;
import ${basePackage}.frame.excel.exception.ReadErrorException;
import ${basePackage}.frame.excel.exception.TemplateNotMatchException;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.TreeNode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;

import java.io.IOException;
import java.net.URLEncoder;

public class DictAjax {

    @Autowired
    private DictManager dictManager;

    public DictCreateResponse create(TreeNode jsonParam) {
        DictCreateRequest request = MapperUtil.toJava(jsonParam, DictCreateRequest.class);
        return dictManager.create(request, LocalData.getToken());
    }

    public DictDeleteResponse delete(TreeNode jsonParam) {
        DictDeleteRequest request = MapperUtil.toJava(jsonParam, DictDeleteRequest.class);
        return dictManager.delete(request, LocalData.getToken());
    }

    public DictUpdateResponse update(TreeNode jsonParam) {
        DictUpdateRequest request = MapperUtil.toJava(jsonParam, DictUpdateRequest.class);
        return dictManager.update(request, LocalData.getToken());
    }

    public DictFindResponse find(TreeNode jsonParam) {
        DictFindRequest request = MapperUtil.toJava(jsonParam, DictFindRequest.class);
        return dictManager.find(request, LocalData.getToken());
    }

    public DictGetResponse get(TreeNode jsonParam) {
        DictGetRequest request = MapperUtil.toJava(jsonParam, DictGetRequest.class);
        return dictManager.get(request, LocalData.getToken());
    }

    public DictLoadResponse load(TreeNode jsonParam) {
        DictLoadRequest request = MapperUtil.toJava(jsonParam, DictLoadRequest.class);
        return dictManager.load(request, LocalData.getToken());
    }

    public Object template(){
        try {
            WSheet<DictCreateRequest> sheet = new WSheet<>(DictCreateRequest.class);
            byte[] bytes = sheet.getBytes();
            HttpHeaders headers = new HttpHeaders();
            headers.setContentType(MediaType.APPLICATION_OCTET_STREAM);
            headers.setContentDispositionFormData("attachment", URLEncoder.encode(sheet.getName() + ".xlsx","utf-8"));
            return new ResponseEntity<>(bytes, headers, HttpStatus.OK);
        } catch (IOException e) {
            BaseResponse baseResponse = new BaseResponse();
            baseResponse.addError(ErrorType.BUSINESS_ERROR, "");
            return baseResponse;
        }
    }

    public Object imports(MultipartFile file) {
        BaseResponse baseResponse = new BaseResponse();
        try {
            byte[] bytes = file.getBytes();

            WSheet<DictCreateRequest> sheet = new WSheet<>(bytes, DictCreateRequest.class);

            if (sheet.hasError()) {
                byte[] sheetBytes = sheet.getBytes(true);
                HttpHeaders headers = new HttpHeaders();
                headers.setContentType(MediaType.APPLICATION_OCTET_STREAM);
                headers.setContentDispositionFormData("attachment", URLEncoder.encode(sheet.getName() + ".xlsx","utf-8"));
                return new ResponseEntity<>(sheetBytes, headers, HttpStatus.OK);
            } else {
                return baseResponse;
            }
        } catch (IOException e) {
            baseResponse.addError(ErrorType.BUSINESS_ERROR, "上传文件出错");
        } catch (TemplateNotMatchException | ReadErrorException e) {
            baseResponse.addError(ErrorType.BUSINESS_ERROR, e.getMessage());
        }

        return baseResponse;
    }
}
